use crate::{schema, UIDCError, config::Config, token};
use microrm::prelude::*;

pub fn create_auth_token(qi: &microrm::QueryInterface, config: &Config, realm_id: schema::RealmID, client: &str, username: &str, scopes: &str) -> Result<String, UIDCError> {
    Ok(token::generate_auth_token(
        &config,
        &qi,
        realm_id,
        qi.get()
            .by(schema::Client::Realm, &realm_id)
            .by(schema::Client::Shortname, client)
            .one()?
            .expect("no such client")
            .id(),
        qi.get()
            .by(schema::User::Realm, &realm_id)
            .by(schema::User::Username, username)
            .one()?
            .expect("no such user")
            .id(),
        scopes.split_whitespace(),
    )?)
}
